Index: /palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_module.f90	(revision 4140)
+++ /palm/trunk/SOURCE/data_output_module.f90	(revision 4141)
@@ -1295,15 +973,17 @@
    ENDIF
 
-   attribute%name       = TRIM( name )
+   attribute%name       = TRIM( attribute_name )
    attribute%data_type  = 'char'
    attribute%value_char = TRIM( value )
 
-   IF ( PRESENT( variable ) )  THEN
-      return_value = dom_def_att_save( TRIM( filename ), TRIM( variable ), &
-                                       attribute=attribute, append=append_internal )
+   IF ( PRESENT( variable_name ) )  THEN
+      variable_name_internal = TRIM( variable_name )
    ELSE
-      return_value = dom_def_att_save( TRIM( filename ), &
-                                       attribute=attribute, append=append_internal )
+      variable_name_internal = ''
    ENDIF
+
+   return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
+                     variable_name=TRIM( variable_name_internal ),         &
+                     attribute=attribute, append=append_internal )
 
 END FUNCTION dom_def_att_char
@@ -1313,10 +993,26 @@
 ! ------------
 !> Create attribute with value of type int8.
-!--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_att_int8( filename, variable, name, value, append ) RESULT( return_value )
-
-   CHARACTER(LEN=*), INTENT(IN)           ::  filename  !< name of file
-   CHARACTER(LEN=*), INTENT(IN)           ::  name      !< name of attribute
-   CHARACTER(LEN=*), INTENT(IN), OPTIONAL ::  variable  !< name of variable
+!> If the optional argument 'variable_name' is given, the attribute is added to the respective
+!> variable or dimension of that name. Otherwise, the attribute is added as a global attribute to
+!> the file itself.
+!> Numerical attributes cannot be appended, only updated (append=.TRUE. will cause an error).
+!> Example call:
+!>   - define a global file attribute:
+!>      dom_def_att( file_name='my_output_file_name', &
+!>                   attribute_name='my_attribute', &
+!>                   value=0_1 )
+!>   - define a variable attribute:
+!>      dom_def_att( file_name='my_output_file_name', &
+!>                   variable_name='my_variable', &
+!>                   attribute_name='my_attribute', &
+!>                   value=1_1 )
+!--------------------------------------------------------------------------------------------------!
+FUNCTION dom_def_att_int8( file_name, variable_name, attribute_name, value, append ) &
+            RESULT( return_value )
+
+   CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
+   CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
+   CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
+   CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_int8'  !< name of routine
@@ -1324,5 +1020,5 @@
    INTEGER(KIND=1), INTENT(IN) ::  value  !< attribute value
 
-   INTEGER(iwp) ::  return_value  !< return value
+   INTEGER ::  return_value  !< return value
 
    LOGICAL                       ::  append_internal  !< same as 'append'
@@ -1333,12 +1029,19 @@
 
    return_value = 0
+
+   IF ( PRESENT( variable_name ) )  THEN
+      variable_name_internal = TRIM( variable_name )
+   ELSE
+      variable_name_internal = ''
+   ENDIF
 
    IF ( PRESENT( append ) )  THEN
       IF ( append )  THEN
          return_value = 1
-         CALL internal_message( 'error',                           &
-                                routine_name //                    &
-                                ': attribute "' // TRIM( name ) // &
-                                '": append of numeric attribute not possible.' )
+         CALL internal_message( 'error', routine_name //                             &
+                                ': numeric attribute cannot be appended ' //         &
+                                '(attribute "' // TRIM( attribute_name ) //          &
+                                '", variable "' // TRIM( variable_name_internal ) // &
+                                '", file "' // TRIM( file_name ) // '")!' )
       ENDIF
    ENDIF
@@ -1347,15 +1050,11 @@
       append_internal = .FALSE.
 
-      attribute%name       = TRIM( name )
+      attribute%name       = TRIM( attribute_name )
       attribute%data_type  = 'int8'
       attribute%value_int8 = value
 
-      IF ( PRESENT( variable ) )  THEN
-         return_value = dom_def_att_save( TRIM( filename ), TRIM( variable ), &
-                                              attribute=attribute, append=append_internal )
-      ELSE
-         return_value = dom_def_att_save( TRIM( filename ), &
-                                              attribute=attribute, append=append_internal )
-      ENDIF
+      return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
+                        variable_name=TRIM( variable_name_internal ),         &
+                        attribute=attribute, append=append_internal )
    ENDIF
 
@@ -1366,10 +1065,26 @@
 ! ------------
 !> Create attribute with value of type int16.
-!--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_att_int16( filename, variable, name, value, append ) RESULT( return_value )
-
-   CHARACTER(LEN=*), INTENT(IN)           ::  filename  !< name of file
-   CHARACTER(LEN=*), INTENT(IN)           ::  name      !< name of attribute
-   CHARACTER(LEN=*), INTENT(IN), OPTIONAL ::  variable  !< name of variable
+!> If the optional argument 'variable_name' is given, the attribute is added to the respective
+!> variable or dimension of that name. Otherwise, the attribute is added as a global attribute to
+!> the file itself.
+!> Numerical attributes cannot be appended, only updated (append=.TRUE. will cause an error).
+!> Example call:
+!>   - define a global file attribute:
+!>      dom_def_att( file_name='my_output_file_name', &
+!>                   attribute_name='my_attribute', &
+!>                   value=0_2 )
+!>   - define a variable attribute:
+!>      dom_def_att( file_name='my_output_file_name', &
+!>                   variable_name='my_variable', &
+!>                   attribute_name='my_attribute', &
+!>                   value=1_2 )
+!--------------------------------------------------------------------------------------------------!
+FUNCTION dom_def_att_int16( file_name, variable_name, attribute_name, value, append ) &
+            RESULT( return_value )
+
+   CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
+   CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
+   CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
+   CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_int16'  !< name of routine
@@ -1377,5 +1092,5 @@
    INTEGER(KIND=2), INTENT(IN) ::  value  !< attribute value
 
-   INTEGER(iwp) ::  return_value  !< return value
+   INTEGER ::  return_value  !< return value
 
    LOGICAL                       ::  append_internal  !< same as 'append'
@@ -1386,12 +1101,19 @@
 
    return_value = 0
+
+   IF ( PRESENT( variable_name ) )  THEN
+      variable_name_internal = TRIM( variable_name )
+   ELSE
+      variable_name_internal = ''
+   ENDIF
 
    IF ( PRESENT( append ) )  THEN
       IF ( append )  THEN
          return_value = 1
-         CALL internal_message( 'error',                           &
-                                routine_name //                    &
-                                ': attribute "' // TRIM( name ) // &
-                                '": append of numeric attribute not possible.' )
+         CALL internal_message( 'error', routine_name //                             &
+                                ': numeric attribute cannot be appended ' //         &
+                                '(attribute "' // TRIM( attribute_name ) //          &
+                                '", variable "' // TRIM( variable_name_internal ) // &
+                                '", file "' // TRIM( file_name ) // '")!' )
       ENDIF
    ENDIF
@@ -1400,15 +1122,11 @@
       append_internal = .FALSE.
 
-      attribute%name        = TRIM( name )
+      attribute%name        = TRIM( attribute_name )
       attribute%data_type   = 'int16'
       attribute%value_int16 = value
 
-      IF ( PRESENT( variable ) )  THEN
-         return_value = dom_def_att_save( TRIM( filename ), TRIM( variable ), &
-                                               attribute=attribute, append=append_internal )
-      ELSE
-         return_value = dom_def_att_save( TRIM( filename ), &
-                                               attribute=attribute, append=append_internal )
-      ENDIF
+      return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
+                        variable_name=TRIM( variable_name_internal ),         &
+                        attribute=attribute, append=append_internal )
    ENDIF
 
@@ -1419,10 +1137,26 @@
 ! ------------
 !> Create attribute with value of type int32.
-!--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_att_int32( filename, variable, name, value, append ) RESULT( return_value )
-
-   CHARACTER(LEN=*), INTENT(IN)           ::  filename  !< name of file
-   CHARACTER(LEN=*), INTENT(IN)           ::  name      !< name of attribute
-   CHARACTER(LEN=*), INTENT(IN), OPTIONAL ::  variable  !< name of variable
+!> If the optional argument 'variable_name' is given, the attribute is added to the respective
+!> variable or dimension of that name. Otherwise, the attribute is added as a global attribute to
+!> the file itself.
+!> Numerical attributes cannot be appended, only updated (append=.TRUE. will cause an error).
+!> Example call:
+!>   - define a global file attribute:
+!>      dom_def_att( file_name='my_output_file_name', &
+!>                   attribute_name='my_attribute', &
+!>                   value=0_4 )
+!>   - define a variable attribute:
+!>      dom_def_att( file_name='my_output_file_name', &
+!>                   variable_name='my_variable', &
+!>                   attribute_name='my_attribute', &
+!>                   value=1_4 )
+!--------------------------------------------------------------------------------------------------!
+FUNCTION dom_def_att_int32( file_name, variable_name, attribute_name, value, append ) &
+            RESULT( return_value )
+
+   CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
+   CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
+   CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
+   CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_int32'  !< name of routine
@@ -1430,5 +1164,5 @@
    INTEGER(KIND=4), INTENT(IN) ::  value  !< attribute value
 
-   INTEGER(iwp) ::  return_value  !< return value
+   INTEGER ::  return_value  !< return value
 
    LOGICAL                       ::  append_internal  !< same as 'append'
@@ -1439,12 +1173,19 @@
 
    return_value = 0
+
+   IF ( PRESENT( variable_name ) )  THEN
+      variable_name_internal = TRIM( variable_name )
+   ELSE
+      variable_name_internal = ''
+   ENDIF
 
    IF ( PRESENT( append ) )  THEN
       IF ( append )  THEN
          return_value = 1
-         CALL internal_message( 'error',                           &
-                                routine_name //                    &
-                                ': attribute "' // TRIM( name ) // &
-                                '": append of numeric attribute not possible.' )
+         CALL internal_message( 'error', routine_name //                             &
+                                ': numeric attribute cannot be appended ' //         &
+                                '(attribute "' // TRIM( attribute_name ) //          &
+                                '", variable "' // TRIM( variable_name_internal ) // &
+                                '", file "' // TRIM( file_name ) // '")!' )
       ENDIF
    ENDIF
@@ -1453,15 +1194,11 @@
       append_internal = .FALSE.
 
-      attribute%name        = TRIM( name )
+      attribute%name        = TRIM( attribute_name )
       attribute%data_type   = 'int32'
       attribute%value_int32 = value
 
-      IF ( PRESENT( variable ) )  THEN
-         return_value = dom_def_att_save( TRIM( filename ), TRIM( variable ), &
-                                               attribute=attribute, append=append_internal )
-      ELSE
-         return_value = dom_def_att_save( TRIM( filename ), &
-                                               attribute=attribute, append=append_internal )
-      ENDIF
+      return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
+                        variable_name=TRIM( variable_name_internal ),         &
+                        attribute=attribute, append=append_internal )
    ENDIF
 
@@ -1472,14 +1209,30 @@
 ! ------------
 !> Create attribute with value of type real32.
-!--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_att_real32( filename, variable, name, value, append ) RESULT( return_value )
-
-   CHARACTER(LEN=*), INTENT(IN)           ::  filename  !< name of file
-   CHARACTER(LEN=*), INTENT(IN)           ::  name      !< name of attribute
-   CHARACTER(LEN=*), INTENT(IN), OPTIONAL ::  variable  !< name of variable
+!> If the optional argument 'variable_name' is given, the attribute is added to the respective
+!> variable or dimension of that name. Otherwise, the attribute is added as a global attribute to
+!> the file itself.
+!> Numerical attributes cannot be appended, only updated (append=.TRUE. will cause an error).
+!> Example call:
+!>   - define a global file attribute:
+!>      dom_def_att( file_name='my_output_file_name', &
+!>                   attribute_name='my_attribute', &
+!>                   value=1.0_4 )
+!>   - define a variable attribute:
+!>      dom_def_att( file_name='my_output_file_name', &
+!>                   variable_name='my_variable', &
+!>                   attribute_name='my_attribute', &
+!>                   value=1.0_4 )
+!--------------------------------------------------------------------------------------------------!
+FUNCTION dom_def_att_real32( file_name, variable_name, attribute_name, value, append ) &
+            RESULT( return_value )
+
+   CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
+   CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
+   CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
+   CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_real32'  !< name of routine
 
-   INTEGER(iwp) ::  return_value  !< return value
+   INTEGER ::  return_value  !< return value
 
    LOGICAL                       ::  append_internal  !< same as 'append'
@@ -1492,12 +1245,19 @@
 
    return_value = 0
+
+   IF ( PRESENT( variable_name ) )  THEN
+      variable_name_internal = TRIM( variable_name )
+   ELSE
+      variable_name_internal = ''
+   ENDIF
 
    IF ( PRESENT( append ) )  THEN
       IF ( append )  THEN
          return_value = 1
-         CALL internal_message( 'error',                           &
-                                routine_name //                    &
-                                ': attribute "' // TRIM( name ) // &
-                                '": append of numeric attribute not possible.' )
+         CALL internal_message( 'error', routine_name //                             &
+                                ': numeric attribute cannot be appended ' //         &
+                                '(attribute "' // TRIM( attribute_name ) //          &
+                                '", variable "' // TRIM( variable_name_internal ) // &
+                                '", file "' // TRIM( file_name ) // '")!' )
       ENDIF
    ENDIF
@@ -1506,15 +1266,11 @@
       append_internal = .FALSE.
 
-      attribute%name         = TRIM( name )
+      attribute%name         = TRIM( attribute_name )
       attribute%data_type    = 'real32'
       attribute%value_real32 = value
 
-      IF ( PRESENT( variable ) )  THEN
-         return_value = dom_def_att_save( TRIM( filename ), TRIM( variable ), &
-                                                attribute=attribute, append=append_internal )
-      ELSE
-         return_value = dom_def_att_save( TRIM( filename ), &
-                                                attribute=attribute, append=append_internal )
-      ENDIF
+      return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
+                        variable_name=TRIM( variable_name_internal ),         &
+                        attribute=attribute, append=append_internal )
    ENDIF
 
@@ -1525,14 +1281,30 @@
 ! ------------
 !> Create attribute with value of type real64.
-!--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_att_real64( filename, variable, name, value, append ) RESULT( return_value )
-
-   CHARACTER(LEN=*), INTENT(IN)           ::  filename  !< name of file
-   CHARACTER(LEN=*), INTENT(IN)           ::  name      !< name of attribute
-   CHARACTER(LEN=*), INTENT(IN), OPTIONAL ::  variable  !< name of variable
+!> If the optional argument 'variable_name' is given, the attribute is added to the respective
+!> variable or dimension of that name. Otherwise, the attribute is added as a global attribute to
+!> the file itself.
+!> Numerical attributes cannot be appended, only updated (append=.TRUE. will cause an error).
+!> Example call:
+!>   - define a global file attribute:
+!>      dom_def_att( file_name='my_output_file_name', &
+!>                   attribute_name='my_attribute', &
+!>                   value=0.0_8 )
+!>   - define a variable attribute:
+!>      dom_def_att( file_name='my_output_file_name', &
+!>                   variable_name='my_variable', &
+!>                   attribute_name='my_attribute', &
+!>                   value=1.0_8 )
+!--------------------------------------------------------------------------------------------------!
+FUNCTION dom_def_att_real64( file_name, variable_name, attribute_name, value, append ) &
+            RESULT( return_value )
+
+   CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
+   CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
+   CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
+   CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_real64'  !< name of routine
 
-   INTEGER(iwp) ::  return_value  !< return value
+   INTEGER ::  return_value  !< return value
 
    LOGICAL                       ::  append_internal  !< same as 'append'
@@ -1545,12 +1317,19 @@
 
    return_value = 0
+
+   IF ( PRESENT( variable_name ) )  THEN
+      variable_name_internal = TRIM( variable_name )
+   ELSE
+      variable_name_internal = ''
+   ENDIF
 
    IF ( PRESENT( append ) )  THEN
       IF ( append )  THEN
          return_value = 1
-         CALL internal_message( 'error',                           &
-                                routine_name //                    &
-                                ': attribute "' // TRIM( name ) // &
-                                '": append of numeric attribute not possible.' )
+         CALL internal_message( 'error', routine_name //                             &
+                                ': numeric attribute cannot be appended ' //         &
+                                '(attribute "' // TRIM( attribute_name ) //          &
+                                '", variable "' // TRIM( variable_name_internal ) // &
+                                '", file "' // TRIM( file_name ) // '")!' )
       ENDIF
    ENDIF
